<template>
  <single-pane :capt="dictionaryRu.title">
    <ob-table
      :columns="columnsObTable"
      :functionalPanel="true"
      :remote-opt="getObTableData"
      :show-add-button="true"
      :add-button-text="dictionaryRu.add_button_title"
      is-fixed-header
      @select="onSelection"
      @add="onAdd"
      ref="obTable"
    />

    <ob-modal
      ref="viewItem"
      :title="newStatus ? dictionaryRu.modal.add_title : dictionaryRu.modal.view_title"
      :is-show-pagination="!newStatus"
      :is-show-controls="false"
    >
      <document-type
        :data-source="selectedData"
        :api="api"
        @delete="onDelete"
        @submit="preparedSave"
        @refresh="onRefresh"
      />
    </ob-modal>
  </single-pane>
</template>

<script>
import DocumentType          from './modal/DocModal';
import paging                from '@/mixins/dictionaries/paging';
import itemMixin             from '@/mixins/dictionaries/edit-item';
import SinglePane            from 'common-components/src/obComponents/obSinglePanels';
import ObModal               from 'common-components/src/obComponents/obModal';
import ObTable               from 'common-components/src/obComponents/obTable';
import { dictionaryDefault } from '@/translations/ru/default'
import { dictionary }        from '@/translations/ru/dictionaries__services__document_types'

export default {
  name: 'DocumentTypes',
  components: {
    ObModal,
    ObTable,
    SinglePane,
    DocumentType
  },
  mixins: [
    paging,
    itemMixin
  ],
  computed: {
    columnsObTable() {
      return [
        {
          title: this.dictionaryRu.columns.name,
          key: 'name'
        },
        {
          title: this.dictionaryRu.columns.document_class,
          key: 'document_class',
          width: '30%',
          html: data => {
            return data.document_class
              ? this.documentClassMap[data.document_class.toLowerCase()]
              : '';
          }
        },
        {
          title: this.dictionaryRu.columns.status,
          width: 110,
          key: 'is_active',
          allowSorting: false,
          html: data => {
            return !data.is_active
              ? this.dictionaryRu.status.inactive
              : this.dictionaryRu.status.active;
          }
        }
      ];
    }
  },
  data() {
    return {
      dataGridRefName: 'DocumentTypes',
      api: {
        source: '/oboz2-dictionary-doc-types-crud/v1/'
      },
      documentClassMap: {
        logistic: 'Логистический документ',
        financial_closing: 'Закрывающий финансовый документ',
        bill: 'Счет'
      },
      dictionaryRu: Object.assign(dictionary, dictionaryDefault)
    };
  },
  methods: {
    preparedSave(payload) {
      this.onSave(payload);
    }
  }
};
</script>